<?php
require_once(__DIR__ . '/vendor/autoload.php');
// key_prod= 'key_42jdaRTi8dxjD2iR7GfOYG5'
// key_test = 'key_gvIHiKoQqRq89kxbP1CQIkU'
class ConektaPayment {
    private $config;
    public function __construct() {
        $this->config = Conekta\Configuration::getDefaultConfiguration()->setAccessToken('key_gvIHiKoQqRq89kxbP1CQIkU');
    }


    public function createCustomer ($input){
        $customer = new \Conekta\Model\Customer(
            [
                'name' => $input['name'],
                'email' => $input['email'],
                'phone' => $input['phone'],
            ]
        ); // \Conekta\Model\Customer | requested field for customer
        // $accept_language = "es"; //
        $apiInstance = new Conekta\Api\CustomersApi(
            new GuzzleHttp\Client(),
            $this->config
        );
        
        try {
            $result = $apiInstance->createCustomer($customer);
            return $result['id'];
        } catch (Exception $e) {
            echo 'Exception when calling CustomersApi->createCustomer: ', $e->getMessage(), PHP_EOL;
        }
        
    }


    function createOrder ($idcustomer,$input){     
        $apiInstance = new Conekta\Api\OrdersApi(
        // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
        // This is optional, `GuzzleHttp\Client` will be used as default.
        new GuzzleHttp\Client(),
        $this->config
    );

    $thirty_days_from_now = (new DateTime())->add(new DateInterval('P30D'))->getTimestamp();

    $order_request = new \Conekta\Model\OrderRequest([
        'currency' => 'MXN',
            'customer_info' => [
                'customer_id' => $idcustomer
            ],
            'line_items' => [
                [
                    'name' => $input['product'],
                    'unit_price' => (int)$input['price'],
                    'quantity' => 1
                ]
            ],
            'charges' => [
                [
                    'payment_method' => [
                        'type' => 'spei',
                        'expires_at' => $thirty_days_from_now
                    ],
                    'amount' => (int)$input['price'] // total charge
                ]
            ]
        ]);
    // \Conekta\Model\OrderRequest | requested field for order


    try {
        $result = $apiInstance->createOrder($order_request);
        return $result;
    } catch (Exception $e) {
        echo 'Exception when calling OrdersApi->createOrder: ', $e->getMessage(), PHP_EOL;
    }
    }
}


$requestMethod = $_SERVER['REQUEST_METHOD'];
$payment = new ConektaPayment();
if($requestMethod == 'POST'){
    $input = json_decode(file_get_contents('php://input'),true);

    if(isset($input['name']) && isset($input['email']) && isset($input['phone']) && isset($input['product']) && isset($input['price'])){
        $idcustomer = $payment -> createCustomer($input);
        $order = $payment -> createOrder($idcustomer,$input);
    
        $clabe = $order['charges']['data'][0]['payment_method']['clabe'];
        if(isset($clabe)){
            echo json_encode(["message" => "Ficha de pago generada correctamente" , "order" => $clabe]);
        }
    
    }else{
        echo json_encode(["error" => "Datos incompletos, favor de completar los datos para generar la ficha de pago"]);
    }

}
?>